Sound = {};

  
function Sound.prerequisitesPresent(specializations)
      return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Sound:load(savegame)

    self.translationMax = false;    self.translationMax2 = false;
    
        local motoSound = getXMLString(xmlFile, "vehicle.motoSound#file");
       if motoSound ~= nil and motoSound ~= "" then
           motoSound = Utils.getFilename(motoSound, self.baseDirectory);
           self.motoSound = createSample("motoSound");
           loadSample(self.motoSound, motoSound, false);
           self.motoSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchOffset"), 0);
           self.motoSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchScale"), 0.05);
           self.motoSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchMax"), 2.0);
           self.motoSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#volume"), 1.0);
           self.motoSoundEnabled = false;
       end;
       
       local vibraSound = getXMLString(xmlFile, "vehicle.vibraSound#file");
       if vibraSound ~= nil and vibraSound ~= "" then
           vibraSound = Utils.getFilename(vibraSound, self.baseDirectory);
           self.vibraSound = createSample("vibraSound");
           loadSample(self.vibraSound, vibraSound, false);
           self.vibraSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.vibraSound#pitchOffset"), 0);
           self.vibraSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.vibraSound#pitchScale"), 0.05);
           self.vibraSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.vibraSound#pitchMax"), 2.0);
           self.vibraSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.vibraSound#volume"), 1.0);
           self.vibraSoundEnabled = false;
       end;
       

       
 self.regime = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime#index"));
 self.regime2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime2#index"));
    

    local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;

    local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;
        
end;
  
function Sound:delete()
end;
 
   function Sound:readStream(streamId, connection)
   end;
 
   function Sound:writeStream(streamId, connection)
   end;
 

   function Sound:readUpdateStream(streamId, timestamp, connection)
   end;

   function Sound:writeUpdateStream(streamId, connection, dirtyMask)
   end;
   
   function Sound:mouseEvent(posX, posY, isDown, isUp, button)
   end;
 
   function Sound:keyEvent(unicode, sym, modifier, isDown)
   end;
 
   function Sound:update(dt)
   
   
           if self.isTurnedOn then
            self.translationMax = true ;
        else    
             self.translationMax = false;
        end;

       if self.translationMax ~= nil then
        local x, y, z = getTranslation(self.translationPart.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax);
        setTranslation(self.translationPart.node, unpack(newTrans));
    end;
    
    if self.translationMax2 ~= nil then
        local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2);
        setTranslation(self.translationPart2.node, unpack(newTrans));
    end;
    
    
        if self.isMotorStarted then
            if self:getIsActiveForSound() then
               if self.motoSound ~= nil and not self.motoSoundEnabled then
                   playSample(self.motoSound, 0, self.motoSoundVolume, 8);
                   self.motoSoundEnabled = true;
               end;
            end;
            local x,y,z = getTranslation(self.regime);
            local a,b,c = getTranslation(self.regime2);
            print(b)
            if b < 4.1 then 
                 setSampleVolume(self.motoSound, 0);
                 setSampleVolume(self.motorSound, 8);
            else 
                setSampleVolume(self.motoSound, 18);
                setSampleVolume(self.motorSound, 0);
            end;
              
            local benne = Utils.vector3Length(x-a, y-b, z-c);
            if self.motoSound ~= nil then
                setSamplePitch(self.motoSound, math.min(self.motoSoundPitchOffset + self.motoSoundPitchScale*math.abs(benne), self.motoSoundPitchMax));
            end;

            if self:getIsActiveForSound() then
               if self.vibraSound ~= nil and not self.vibraSoundEnabled then
                   playSample(self.vibraSound, 0, self.vibraSoundVolume, 8);
                   self.vibraSoundEnabled = true;
               end;
            end;
            local x,y,z = getTranslation(self.regime);
            local a,b,c = getTranslation(self.regime2);
            print(b)
            if b < 4.1 then 
                 setSampleVolume(self.vibraSound, 0);
            else 
                setSampleVolume(self.vibraSound, 1);
            end;
              
            local benne = Utils.vector3Length(x-a, y-b, z-c);
            if self.vibraSound ~= nil then
                setSamplePitch(self.vibraSound, math.min(self.vibraSoundPitchOffset + self.vibraSoundPitchScale*math.abs(benne), self.vibraSoundPitchMax));
            end;
        end;
   
   
   
   end;
 
   function Sound:updateTick(dt)
 
   end;
 
   function Sound:draw()
   
   end;
   
   
   function Sound:onLeave()
           if self.motoSound ~= nil then
               stopSample(self.motoSound);
               self.motoSoundEnabled = false;

           end;
    if self.vibraSound ~= nil and self.vibraSoundEnabled then
        stopSample(self.vibraSound);
        self.vibraSoundEnabled = false;

    end;
           
        self.translationMax = false;
        self.translationMax2 = false;
 
end;  
      






function Sound:onDeactivate()

           if self.motoSound ~= nil then
               stopSample(self.motoSound);
               self.motoSoundEnabled = false;

           end;
    if self.vibraSound ~= nil and self.vibraSoundEnabled then
        stopSample(self.vibraSound);
        self.vibraSoundEnabled = false;

    end;
end;
 

